/// @cond EO_CXX_EO_IMPL

inline ::elm::widget_item elm::genlist::item_insert_before(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, ::elm::widget_item before_it_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_insert_before(itc_, data_, ::efl::eolian::to_c(parent_), ::efl::eolian::to_c(before_it_), type_, func_, func_data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist::realized_items_update() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_realized_items_update());
}

inline ::elm::widget_item elm::genlist::item_insert_after(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, ::elm::widget_item after_it_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_insert_after(itc_, data_, ::efl::eolian::to_c(parent_), ::efl::eolian::to_c(after_it_), type_, func_, func_data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::genlist::at_xy_item_get(Evas_Coord x_, Evas_Coord y_, int* posret_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_at_xy_item_get(x_, y_, posret_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline Eina_Iterator * elm::genlist::filter_iterator_new() const
{
   Eina_Iterator * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_filter_iterator_new());
   return _tmp_ret;
}

inline unsigned int elm::genlist::items_count() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_items_count());
   return _tmp_ret;
}

inline ::elm::widget_item elm::genlist::item_prepend(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_prepend(itc_, data_, ::efl::eolian::to_c(parent_), type_, func_, func_data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_clear());
}

inline ::elm::widget_item elm::genlist::item_append(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_append(itc_, data_, ::efl::eolian::to_c(parent_), type_, func_, func_data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::genlist::item_sorted_insert(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, Elm_Genlist_Item_Type type_, Eina_Compare_Cb comp_, Evas_Smart_Cb func_, const void * func_data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_sorted_insert(itc_, data_, ::efl::eolian::to_c(parent_), type_, comp_, func_, func_data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::genlist::search_by_text_item_get(::elm::widget_item item_to_search_from_, ::efl::eina::string_view part_name_, ::efl::eina::string_view pattern_, Elm_Glob_Match_Flags flags_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_search_by_text_item_get(::efl::eolian::to_c(item_to_search_from_), ::efl::eolian::to_c(part_name_), ::efl::eolian::to_c(pattern_), flags_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool elm::genlist::homogeneous_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_homogeneous_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist::homogeneous_set(bool homogeneous_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_homogeneous_set(::efl::eolian::to_c(homogeneous_)));
}

inline Elm_Object_Select_Mode elm::genlist::select_mode_get() const
{
   Elm_Object_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_select_mode_get());
   return _tmp_ret;
}

inline void elm::genlist::select_mode_set(Elm_Object_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_select_mode_set(mode_));
}

inline bool elm::genlist::focus_on_selection_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_focus_on_selection_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist::focus_on_selection_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_focus_on_selection_set(::efl::eolian::to_c(enabled_)));
}

inline double elm::genlist::longpress_timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_longpress_timeout_get());
   return _tmp_ret;
}

inline void elm::genlist::longpress_timeout_set(double timeout_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_longpress_timeout_set(timeout_));
}

inline bool elm::genlist::multi_select_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_multi_select_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist::multi_select_set(bool multi_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_multi_select_set(::efl::eolian::to_c(multi_)));
}

inline bool elm::genlist::reorder_mode_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_reorder_mode_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist::reorder_mode_set(bool reorder_mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_reorder_mode_set(::efl::eolian::to_c(reorder_mode_)));
}

inline bool elm::genlist::decorate_mode_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_decorate_mode_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist::decorate_mode_set(bool decorated_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_decorate_mode_set(::efl::eolian::to_c(decorated_)));
}

inline Elm_Object_Multi_Select_Mode elm::genlist::multi_select_mode_get() const
{
   Elm_Object_Multi_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_multi_select_mode_get());
   return _tmp_ret;
}

inline void elm::genlist::multi_select_mode_set(Elm_Object_Multi_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_multi_select_mode_set(mode_));
}

inline int elm::genlist::block_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_block_count_get());
   return _tmp_ret;
}

inline void elm::genlist::block_count_set(int count_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_block_count_set(count_));
}

inline bool elm::genlist::tree_effect_enabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_tree_effect_enabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist::tree_effect_enabled_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_tree_effect_enabled_set(::efl::eolian::to_c(enabled_)));
}

inline bool elm::genlist::highlight_mode_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_highlight_mode_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist::highlight_mode_set(bool highlight_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_highlight_mode_set(::efl::eolian::to_c(highlight_)));
}

inline Elm_List_Mode elm::genlist::mode_get() const
{
   Elm_List_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_mode_get());
   return _tmp_ret;
}

inline void elm::genlist::mode_set(Elm_List_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_mode_set(mode_));
}

inline ::elm::widget_item elm::genlist::decorated_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_decorated_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::genlist::selected_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_selected_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::genlist::first_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_first_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::list< Elm_Gen_Item * > elm::genlist::realized_items_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_realized_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::list< Elm_Gen_Item * >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
}

inline ::efl::eina::crange_list< ::elm::widget_item > elm::genlist::selected_items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_selected_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item elm::genlist::last_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_last_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::genlist::filter_set(void * key_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_filter_set(key_));
}

inline ::elm::widget_item eo_cxx::elm::genlist::item_insert_before(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, ::elm::widget_item before_it_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_insert_before(itc_, data_, ::efl::eolian::to_c(parent_), ::efl::eolian::to_c(before_it_), type_, func_, func_data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist::realized_items_update() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_realized_items_update());
}

inline ::elm::widget_item eo_cxx::elm::genlist::item_insert_after(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, ::elm::widget_item after_it_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_insert_after(itc_, data_, ::efl::eolian::to_c(parent_), ::efl::eolian::to_c(after_it_), type_, func_, func_data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::genlist::at_xy_item_get(Evas_Coord x_, Evas_Coord y_, int* posret_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_at_xy_item_get(x_, y_, posret_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline Eina_Iterator * eo_cxx::elm::genlist::filter_iterator_new() const
{
   Eina_Iterator * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_filter_iterator_new());
   return _tmp_ret;
}

inline unsigned int eo_cxx::elm::genlist::items_count() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_items_count());
   return _tmp_ret;
}

inline ::elm::widget_item eo_cxx::elm::genlist::item_prepend(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_prepend(itc_, data_, ::efl::eolian::to_c(parent_), type_, func_, func_data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist::clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_clear());
}

inline ::elm::widget_item eo_cxx::elm::genlist::item_append(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_append(itc_, data_, ::efl::eolian::to_c(parent_), type_, func_, func_data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::genlist::item_sorted_insert(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, Elm_Genlist_Item_Type type_, Eina_Compare_Cb comp_, Evas_Smart_Cb func_, const void * func_data_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_item_sorted_insert(itc_, data_, ::efl::eolian::to_c(parent_), type_, comp_, func_, func_data_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::genlist::search_by_text_item_get(::elm::widget_item item_to_search_from_, ::efl::eina::string_view part_name_, ::efl::eina::string_view pattern_, Elm_Glob_Match_Flags flags_) const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_search_by_text_item_get(::efl::eolian::to_c(item_to_search_from_), ::efl::eolian::to_c(part_name_), ::efl::eolian::to_c(pattern_), flags_));
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline bool eo_cxx::elm::genlist::homogeneous_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_homogeneous_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist::homogeneous_set(bool homogeneous_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_homogeneous_set(::efl::eolian::to_c(homogeneous_)));
}

inline Elm_Object_Select_Mode eo_cxx::elm::genlist::select_mode_get() const
{
   Elm_Object_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_select_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::genlist::select_mode_set(Elm_Object_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_select_mode_set(mode_));
}

inline bool eo_cxx::elm::genlist::focus_on_selection_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_focus_on_selection_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist::focus_on_selection_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_focus_on_selection_set(::efl::eolian::to_c(enabled_)));
}

inline double eo_cxx::elm::genlist::longpress_timeout_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_longpress_timeout_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::genlist::longpress_timeout_set(double timeout_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_longpress_timeout_set(timeout_));
}

inline bool eo_cxx::elm::genlist::multi_select_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_multi_select_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist::multi_select_set(bool multi_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_multi_select_set(::efl::eolian::to_c(multi_)));
}

inline bool eo_cxx::elm::genlist::reorder_mode_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_reorder_mode_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist::reorder_mode_set(bool reorder_mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_reorder_mode_set(::efl::eolian::to_c(reorder_mode_)));
}

inline bool eo_cxx::elm::genlist::decorate_mode_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_decorate_mode_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist::decorate_mode_set(bool decorated_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_decorate_mode_set(::efl::eolian::to_c(decorated_)));
}

inline Elm_Object_Multi_Select_Mode eo_cxx::elm::genlist::multi_select_mode_get() const
{
   Elm_Object_Multi_Select_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_multi_select_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::genlist::multi_select_mode_set(Elm_Object_Multi_Select_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_multi_select_mode_set(mode_));
}

inline int eo_cxx::elm::genlist::block_count_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_block_count_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::genlist::block_count_set(int count_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_block_count_set(count_));
}

inline bool eo_cxx::elm::genlist::tree_effect_enabled_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_tree_effect_enabled_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist::tree_effect_enabled_set(bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_tree_effect_enabled_set(::efl::eolian::to_c(enabled_)));
}

inline bool eo_cxx::elm::genlist::highlight_mode_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_highlight_mode_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist::highlight_mode_set(bool highlight_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_highlight_mode_set(::efl::eolian::to_c(highlight_)));
}

inline Elm_List_Mode eo_cxx::elm::genlist::mode_get() const
{
   Elm_List_Mode _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_mode_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::genlist::mode_set(Elm_List_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_mode_set(mode_));
}

inline ::elm::widget_item eo_cxx::elm::genlist::decorated_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_decorated_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::genlist::selected_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_selected_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::genlist::first_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_first_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::list< Elm_Gen_Item * > eo_cxx::elm::genlist::realized_items_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_realized_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::list< Elm_Gen_Item * >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
}

inline ::efl::eina::crange_list< ::elm::widget_item > eo_cxx::elm::genlist::selected_items_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_selected_items_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::genlist::last_item_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_genlist_last_item_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::genlist::filter_set(void * key_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_genlist_filter_set(key_));
}

inline ::eo_cxx::elm::genlist::operator ::elm::genlist() const
{
   return *static_cast<::elm::genlist const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::genlist::operator ::elm::genlist&()
{
   return *static_cast<::elm::genlist*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::genlist::operator ::elm::genlist const&() const
{
   return *static_cast<::elm::genlist const*>(static_cast<void const*>(this));
}

template <typename T>
::elm::widget_item elm_genlist_item_insert_before_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Genlist_Item_Class * itc_, const void * data_, Elm_Widget_Item * parent_, Elm_Widget_Item * before_it_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_insert_before(itc_, data_, ::efl::eolian::to_cxx<::elm::widget_item>(parent_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::elm::widget_item>(before_it_, std::tuple<std::false_type>()), type_, func_, func_data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_realized_items_update_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->realized_items_update();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_genlist_item_insert_after_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Genlist_Item_Class * itc_, const void * data_, Elm_Widget_Item * parent_, Elm_Widget_Item * after_it_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_insert_after(itc_, data_, ::efl::eolian::to_cxx<::elm::widget_item>(parent_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::elm::widget_item>(after_it_, std::tuple<std::false_type>()), type_, func_, func_data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_genlist_at_xy_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_, int* posret_)
{
   try
      {
         return static_cast<T*>(self->this_)->at_xy_item_get(x_, y_, posret_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
Eina_Iterator * elm_genlist_filter_iterator_new_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->filter_iterator_new();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Iterator * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
unsigned int elm_genlist_items_count_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->items_count();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         unsigned int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
::elm::widget_item elm_genlist_item_prepend_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Genlist_Item_Class * itc_, const void * data_, Elm_Widget_Item * parent_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_prepend(itc_, data_, ::efl::eolian::to_cxx<::elm::widget_item>(parent_, std::tuple<std::false_type>()), type_, func_, func_data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_genlist_item_append_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Genlist_Item_Class * itc_, const void * data_, Elm_Widget_Item * parent_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_append(itc_, data_, ::efl::eolian::to_cxx<::elm::widget_item>(parent_, std::tuple<std::false_type>()), type_, func_, func_data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_genlist_item_sorted_insert_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Elm_Genlist_Item_Class * itc_, const void * data_, Elm_Widget_Item * parent_, Elm_Genlist_Item_Type type_, Eina_Compare_Cb comp_, Evas_Smart_Cb func_, const void * func_data_)
{
   try
      {
         return static_cast<T*>(self->this_)->item_sorted_insert(itc_, data_, ::efl::eolian::to_cxx<::elm::widget_item>(parent_, std::tuple<std::false_type>()), type_, comp_, func_, func_data_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_genlist_search_by_text_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Widget_Item * item_to_search_from_, const char * part_name_, const char * pattern_, Elm_Glob_Match_Flags flags_)
{
   try
      {
         return static_cast<T*>(self->this_)->search_by_text_item_get(::efl::eolian::to_cxx<::elm::widget_item>(item_to_search_from_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::string_view>(part_name_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::string_view>(pattern_, std::tuple<std::false_type>()), flags_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
bool elm_genlist_homogeneous_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->homogeneous_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_homogeneous_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool homogeneous_)
{
   try
      {
         static_cast<T*>(self->this_)->homogeneous_set(::efl::eolian::to_cxx<bool>(homogeneous_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Object_Select_Mode elm_genlist_select_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->select_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Object_Select_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_genlist_select_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Object_Select_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->select_mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_genlist_focus_on_selection_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->focus_on_selection_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_focus_on_selection_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enabled_)
{
   try
      {
         static_cast<T*>(self->this_)->focus_on_selection_set(::efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_genlist_longpress_timeout_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->longpress_timeout_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_genlist_longpress_timeout_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double timeout_)
{
   try
      {
         static_cast<T*>(self->this_)->longpress_timeout_set(timeout_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_genlist_multi_select_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->multi_select_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_multi_select_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool multi_)
{
   try
      {
         static_cast<T*>(self->this_)->multi_select_set(::efl::eolian::to_cxx<bool>(multi_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_genlist_reorder_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->reorder_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_reorder_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool reorder_mode_)
{
   try
      {
         static_cast<T*>(self->this_)->reorder_mode_set(::efl::eolian::to_cxx<bool>(reorder_mode_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_genlist_decorate_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->decorate_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_decorate_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool decorated_)
{
   try
      {
         static_cast<T*>(self->this_)->decorate_mode_set(::efl::eolian::to_cxx<bool>(decorated_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Object_Multi_Select_Mode elm_genlist_multi_select_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->multi_select_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Object_Multi_Select_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_genlist_multi_select_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Object_Multi_Select_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->multi_select_mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
int elm_genlist_block_count_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->block_count_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_genlist_block_count_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int count_)
{
   try
      {
         static_cast<T*>(self->this_)->block_count_set(count_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_genlist_tree_effect_enabled_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->tree_effect_enabled_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_tree_effect_enabled_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enabled_)
{
   try
      {
         static_cast<T*>(self->this_)->tree_effect_enabled_set(::efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_genlist_highlight_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->highlight_mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_highlight_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool highlight_)
{
   try
      {
         static_cast<T*>(self->this_)->highlight_mode_set(::efl::eolian::to_cxx<bool>(highlight_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_List_Mode elm_genlist_mode_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->mode_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_List_Mode _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_genlist_mode_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_List_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->mode_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::elm::widget_item elm_genlist_decorated_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->decorated_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_genlist_selected_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_genlist_first_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->first_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::efl::eina::list< Elm_Gen_Item * > elm_genlist_realized_items_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->realized_items_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::list< Elm_Gen_Item * >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
      }
}

template <typename T>
::efl::eina::crange_list< ::elm::widget_item > elm_genlist_selected_items_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_items_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_genlist_last_item_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->last_item_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_genlist_filter_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, void * key_)
{
   try
      {
         static_cast<T*>(self->this_)->filter_set(key_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::genlist >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_scrollable >::template type<T>
         , virtual operations< ::evas::clickable_interface >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
         , virtual operations< ::elm_interface_atspi_selection >::template type<T>
         , virtual operations< ::evas::selectable_interface >::template type<T>
   {
      virtual ::elm::widget_item item_insert_before(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, ::elm::widget_item before_it_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_insert_before(itc_, data_, ::efl::eolian::to_c(parent_), ::efl::eolian::to_c(before_it_), type_, func_, func_data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void realized_items_update()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_realized_items_update());
      }

      virtual ::elm::widget_item item_insert_after(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, ::elm::widget_item after_it_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_insert_after(itc_, data_, ::efl::eolian::to_c(parent_), ::efl::eolian::to_c(after_it_), type_, func_, func_data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item at_xy_item_get(Evas_Coord x_, Evas_Coord y_, int* posret_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_at_xy_item_get(x_, y_, posret_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Eina_Iterator * filter_iterator_new()
      {
         Eina_Iterator * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_filter_iterator_new());
            return _tmp_ret;
      }

      virtual unsigned int items_count()
      {
         unsigned int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_items_count());
            return _tmp_ret;
      }

      virtual ::elm::widget_item item_prepend(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_prepend(itc_, data_, ::efl::eolian::to_c(parent_), type_, func_, func_data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_clear());
      }

      virtual ::elm::widget_item item_append(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, Elm_Genlist_Item_Type type_, Evas_Smart_Cb func_, const void * func_data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_append(itc_, data_, ::efl::eolian::to_c(parent_), type_, func_, func_data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item item_sorted_insert(const Elm_Genlist_Item_Class * itc_, const void * data_, ::elm::widget_item parent_, Elm_Genlist_Item_Type type_, Eina_Compare_Cb comp_, Evas_Smart_Cb func_, const void * func_data_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_item_sorted_insert(itc_, data_, ::efl::eolian::to_c(parent_), type_, comp_, func_, func_data_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item search_by_text_item_get(::elm::widget_item item_to_search_from_, ::efl::eina::string_view part_name_, ::efl::eina::string_view pattern_, Elm_Glob_Match_Flags flags_)
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_search_by_text_item_get(::efl::eolian::to_c(item_to_search_from_), ::efl::eolian::to_c(part_name_), ::efl::eolian::to_c(pattern_), flags_));
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool homogeneous_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_homogeneous_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void homogeneous_set(bool homogeneous_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_homogeneous_set(::efl::eolian::to_c(homogeneous_)));
      }

      virtual Elm_Object_Select_Mode select_mode_get()
      {
         Elm_Object_Select_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_select_mode_get());
            return _tmp_ret;
      }

      virtual void select_mode_set(Elm_Object_Select_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_select_mode_set(mode_));
      }

      virtual bool focus_on_selection_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_focus_on_selection_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void focus_on_selection_set(bool enabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_focus_on_selection_set(::efl::eolian::to_c(enabled_)));
      }

      virtual double longpress_timeout_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_longpress_timeout_get());
            return _tmp_ret;
      }

      virtual void longpress_timeout_set(double timeout_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_longpress_timeout_set(timeout_));
      }

      virtual bool multi_select_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_multi_select_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void multi_select_set(bool multi_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_multi_select_set(::efl::eolian::to_c(multi_)));
      }

      virtual bool reorder_mode_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_reorder_mode_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void reorder_mode_set(bool reorder_mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_reorder_mode_set(::efl::eolian::to_c(reorder_mode_)));
      }

      virtual bool decorate_mode_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_decorate_mode_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void decorate_mode_set(bool decorated_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_decorate_mode_set(::efl::eolian::to_c(decorated_)));
      }

      virtual Elm_Object_Multi_Select_Mode multi_select_mode_get()
      {
         Elm_Object_Multi_Select_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_multi_select_mode_get());
            return _tmp_ret;
      }

      virtual void multi_select_mode_set(Elm_Object_Multi_Select_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_multi_select_mode_set(mode_));
      }

      virtual int block_count_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_block_count_get());
            return _tmp_ret;
      }

      virtual void block_count_set(int count_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_block_count_set(count_));
      }

      virtual bool tree_effect_enabled_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_tree_effect_enabled_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void tree_effect_enabled_set(bool enabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_tree_effect_enabled_set(::efl::eolian::to_c(enabled_)));
      }

      virtual bool highlight_mode_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_highlight_mode_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void highlight_mode_set(bool highlight_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_highlight_mode_set(::efl::eolian::to_c(highlight_)));
      }

      virtual Elm_List_Mode mode_get()
      {
         Elm_List_Mode _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_mode_get());
            return _tmp_ret;
      }

      virtual void mode_set(Elm_List_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_mode_set(mode_));
      }

      virtual ::elm::widget_item decorated_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_decorated_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item selected_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_selected_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item first_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_first_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::efl::eina::list< Elm_Gen_Item * > realized_items_get()
      {
         Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_realized_items_get());
            return ::efl::eolian::to_cxx<::efl::eina::list< Elm_Gen_Item * >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
      }

      virtual ::efl::eina::crange_list< ::elm::widget_item > selected_items_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_selected_items_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual ::elm::widget_item last_item_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_genlist_last_item_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void filter_set(void * key_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_genlist_filter_set(key_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::genlist >
{
   static constexpr int value = 
#if defined(GENLIST_PROTECTED) && defined(GENLIST_BETA)
      42
#elif defined(GENLIST_PROTECTED)
      42
#elif defined(GENLIST_BETA)
      42
#else
      42
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_scrollable >::value      + operation_description_class_size<::evas::clickable_interface >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value      + operation_description_class_size<::elm_interface_atspi_selection >::value      + operation_description_class_size<::evas::selectable_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::genlist>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_insert_before_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_insert_before);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_realized_items_update_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_realized_items_update);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_insert_after_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_insert_after);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_at_xy_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_at_xy_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_filter_iterator_new_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_filter_iterator_new);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_items_count_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_items_count);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_prepend_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_prepend);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_append_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_append);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_item_sorted_insert_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_item_sorted_insert);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_search_by_text_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_search_by_text_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_homogeneous_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_homogeneous_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_homogeneous_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_homogeneous_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_select_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_select_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_select_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_select_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_focus_on_selection_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_focus_on_selection_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_focus_on_selection_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_focus_on_selection_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_longpress_timeout_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_longpress_timeout_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_longpress_timeout_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_longpress_timeout_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_multi_select_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_multi_select_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_multi_select_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_multi_select_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_reorder_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_reorder_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_reorder_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_reorder_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_decorate_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_decorate_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_decorate_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_decorate_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_multi_select_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_multi_select_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_multi_select_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_multi_select_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_block_count_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_block_count_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_block_count_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_block_count_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_tree_effect_enabled_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_tree_effect_enabled_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_tree_effect_enabled_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_tree_effect_enabled_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_highlight_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_highlight_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_highlight_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_highlight_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_mode_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_mode_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_mode_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_mode_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_decorated_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_decorated_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_selected_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_selected_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_first_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_first_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_realized_items_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_realized_items_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_selected_items_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_selected_items_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_last_item_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_last_item_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_genlist_filter_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_genlist_filter_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::genlist >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_scrollable>(), &ops[operation_description_class_size< ::elm::genlist >::value + operation_description_class_size<::elm::layout>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::clickable_interface>(), &ops[operation_description_class_size< ::elm::genlist >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_scrollable>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::genlist >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_scrollable>::value + operation_description_class_size<::evas::clickable_interface>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_selection>(), &ops[operation_description_class_size< ::elm::genlist >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_scrollable>::value + operation_description_class_size<::evas::clickable_interface>::value + operation_description_class_size<::elm_interface_atspi_widget_action>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::selectable_interface>(), &ops[operation_description_class_size< ::elm::genlist >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_scrollable>::value + operation_description_class_size<::evas::clickable_interface>::value + operation_description_class_size<::elm_interface_atspi_widget_action>::value + operation_description_class_size<::elm_interface_atspi_selection>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::genlist>)
{
   return (ELM_GENLIST_CLASS);
}

} } }

/// @endcond

